
;MACROS 
	MACRO
	PrintSuccessMessage
	PUSH	{R0,R1}
	LDR 	R0,=SuccessMessage
	LDR		R1,=SuccessMessagePast
	BL		PutStringSB
	POP		{R0,R1}
	MEND

	MACRO
	PrintFailureMessage
	PUSH	{R0,R1}
	LDR 	R0,=FailureMessage
	LDR		R1,=FailureMessagePast
	BL		PutStringSB
	POP		{R0,R1}
	MEND

	MACRO
	SetCFlag
		PUSH    {R0-R1}
        MRS   R0,APSR           ;move the APSR (special register) into R0
        LDR   R1,=APSR_C_MASK   ; Move the APSR_C_MASK into R1 (APSR_C_MASK = 00100000'00000000'00000000'00000000)
        ORRS  R0,R0,R1          ; logically OR the APSR_C_MASK (R1) with the APSR (R0) to preserver other flags while setting C flag
        MSR   APSR,R0
		POP     {R0-R1}
	MEND


	MACRO
	ClearCFlag
        PUSH    {R0-R1}
        MRS     R0,APSR           ;move the APSR (special register) into R0
        LDR     R1,=APSR_C_MASK   ; ASK WHAT THIS IS DOING WITH PC;; Move the APSR_C_MASK into R1 (APSR_C_MASK = 00100000'00000000'00000000'00000000)
        BICS    R0,R0,R1            ; R0 gets R0 & (~APSR_C_MASK). so since (~APSR_C_MASK) is all ones except where the C flag is, r0 gets the contents of r1 with the C flag cleared
        MSR     APSR,R0             ;
		POP     {R0-R1}
	MEND	

	MACRO
	NewLine
;pushes new line to terminal using carrage return and line feed
	PUSH 	{R0}
	MOVS	R0,#13			; put carriage return in r0
	BL	PutChar			; put carriage return to terminal
	MOVS	R0,#10			; put line feed return in r0
	BL	PutChar			; put line feed  to terminal
	POP     {R0}
	MEND