/*********************************************************************/
/* Lab Exercise todo:Update                                          */
/* bit digital value.                                                */
/* Name:  R. W. Melton                                               */
/* Date:  April 4, 2022                                              */
/* Class:  CMPE 250                                                  */
/* Section:  All sections                                            */
/*********************************************************************/
#define EXERCISE_12_C (1)

#define MAX_STRING (79) //q: how can i import defines from another file? a: 


//typedefs here:
typedef int Int32;
typedef short int Int16;
typedef char Int8;
typedef unsigned int UInt32;
typedef unsigned short int UInt16;
typedef unsigned char UInt8;
// typedef char [MAX_STRING] String; q: can i define a string as an array of chars? is this a bad practice?

/* assembly language ROM table entries */
//todo: update
extern UInt16 DAC0_table_0;
extern UInt16 PWM_duty_table_0;

/* assembly language subroutines */ 
//todo: update

/**
 *  Dequeues a character from the receive queue, and returns it in R0 
 *  @return the character
 */ 
char GetChar (void);

void GetStringSB (char String[], int StringBufferCapacity);
void Init_UART0_IRQ (void);
void PutChar (char Character);


void PutNumHex (UInt32);
/**
 * ;       send the lest significant byte of R0 to terminal as decimal
 */
void PutNumUB (UInt8);
void PutStringSB (char String[], int StringBufferCapacity);

//new functions here:
//todo: header
void StartStopWatch(void);

//todo: header
UInt32 PauseStopWatch(void);

//todo: header
unsigned int* GetStopWatchCountAddress(void);

//todo: header
void initBinaryLEDs(void);

//todo: header
void writeToBinaryLEDs(int LEDStates);

//todo: header
void Init_PIT_IRQ (void);


void initLED0(void);


/**
 *  @brief  set up the onboard LEDs
 *  set up KL46Z pins as GPIOs for onboard LEDs on the FDRM-KL46Z development board
 *  configure cpu pins as GPIOs
 *  configure gpio pins as outputs
 *  set gpio pins to 0
 *  
 */
void initOnboardLEDs(void);

// /**
//  * Turns  the onboard green LED off
//  * writes a 1 to port D pin 5 (PTD5) 
//  */
// void TurnOnboardGreenLEDOff(void);



// /**
//  * Turns the onboard green LED on
//  * Writes a 0 to port D pin 5 (PTD5)
//  */
// void TurnOnboardGreenLEDOn(void);


// /**
//  *  Turns the onboard red LED off
//  *  writes a 1 to port E pin 29 (PTE29) 
//  */
// void TurnOnboardRedLEDOff(void);


// /**
//  * Turns the onboard red LED on
//  * Writes a 0 to port E pin 29 (PTE29)
//  */
// void TurnOnboardRedLEDOn(void);

/**
 * writes the value of R0 to the onboard green LED
 * if R0 is 0, the LED is turned off
 * if R0 is 1, the LED is turned on
 * @param ledValue = the value to write to the onboard green LED
 */

void WriteToGreenLED(UInt8 ledValue);

/**
 * writes the value of R0 to the onboard red LED
 * if R0 is 0, the LED is turned off
 * if R0 is 1, the LED is turned on
 * @param ledValue = the value to write to the onboard red LED
 */
void WriteToRedLED(UInt8 ledValue);


